c |$Id: genb2s.f,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $        |
c --------------------------------------------------------------
c | Basic Seismic Utilities (BSU)                              |
c | LANGUAGE: Fortran77                                        |
c | AUTHOR: P. MICHAELS  http://cgiss.boisestate.edu/~pm       | 
c | PROGRAM NAME: genb2s.f                                     |
c | DIRECTORY: bsu-2.0.2/src/Fort/bsegy                        |
c |------------------------------------------------------------|
c | Generates bash scripts to convert Bison Formatted datat    |
c | to bsegy (*.seg) format.  This is for a quick QC of data   |
c | and creates blank headers (except for number samples and   |
c | sample interval, plus few other items in Bison headers.    |
c |------------------------------------------------------------|
c |  NOTICE:                                                   |
c |  Copyright (C) 2017 Paul Michaels                          |
c |  <pm@cgiss.boisestate.edu>                                 |
c |  This program is free software; you can                    |
c |  redistribute it and/or modify it under the terms          |
c |  of the GNU General Public License as published            |
c |  by the Free Software Foundation; either version           |
c |  3 of the License, or (at your option) any later           |
c |  version.  This program is distributed in the              |
c |  hope that it will be useful, but                          |
c |  WITHOUT ANY WARRANTY; without even the implied            |
c |  warranty of MERCHANTABILITY or FITNESS FOR A              |
c |  PARTICULAR PURPOSE.  See the GNU General Public           |
c |  License for more details.                                 |
c |  You should have received a copy of the GNU                |
c |  General Public License along with this program;           |
c |  if not, write to the Free Software Foundation,            |
c |  Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             |
c |------------------------------------------------------------|
c
      character*5  prfx
c...interactive           
      write(*,*) '|---------------------------------|'
      write(*,*) '| Copyright (C) 2017  P. Michaels |'
      write(*,*) '|       All rights reserved       |'
      write(*,*) '|see GNU General Public License   |'
      write(*,*) '|---------------------------------|'
      write(*,*) ' INTERACTIVE '
      write(*,*) 'Generates bash script to convert BISON to BSEGY '
      write(*,*) ' '
      write(*,*) '  This is for QC of data, and minimal headers '
      write(*,*) 'are created (geometry is zeroed out).        '
      write(*,*) ' '
c
      write(*,*) 'enter 5_LETTER ALPHA PREFIX'
      read(*,'(a)') prfx
      do 11, j=1,5
      if(prfx(j:j).eq.' ') then
      write(*,*) ' ABORT  Must enter first 5 characters of file names'
      jchar=j-1
      write(*,'('' Only '',i1,'' characters read='',a)') 
     +jchar,prfx(1:jchar)
      stop
      endif
11    continue
c
      write(*,*) 'enter 3digit FIRST FILE number'
      read(*,*) ifrst
c
      write(*,*) 'enter 3digit LAST FILE number'
      read(*,*) ilast
c
      open(unit=2,access='sequential',file='gob2s')
c
      nlines=(ilast-ifrst)+1
c
      icount=ifrst
c
      do 10 j=1,nlines
      write(2,100) prfx, icount
  100 format(' bis2seg ',a,i3.3)
      write(2,101) prfx, icount, icount
  101 format(' mv ',a,i3.3,'.seg r',i3.3,'.seg')
      icount=icount+1
   10 continue
      close(2)
      write(*,*) ' OUTPUT =====> gob2s'
      stop
      end
