c  |------------------------------------------------------------|
c  |                                         date: 29 apr 93    |
c  | author: p. michaels                                        |
c  |------------------------------------------------------------|
c  | showmdl: display line printer listing of disper.d model    |
c  |------------------------------------------------------------|
c  |  NOTICE:                                                   |
c  |  Copyright (C) 2017 Paul Michaels                          |
c  |  <pm@cgiss.boisestate.edu>                                 |
c  |  This program is free software; you can                    |
c  |  redistribute it and/or modify it under the terms          |
c  |  of the GNU General Public License as published            |
c  |  by the Free Software Foundation; either version           |
c  |  3 of the License, or (at your option) any later           |
c  |  version.  This program is distributed in the              |
c  |  hope that it will be useful, but                          |
c  |  WITHOUT ANY WARRANTY; without even the implied            |
c  |  warranty of MERCHANTABILITY or FITNESS FOR A              |
c  |  PARTICULAR PURPOSE.  See the GNU General Public           |
c  |  License for more details.                                 |
c  |  You should have received a copy of the GNU                |
c  |  General Public License along with this program;           |
c  |  if not, write to the Free Software Foundation,            |
c  |  Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             |
c  |                                                            |
c  |------------------------------------------------------------|
c
      program main
      parameter (ndim=30)
      implicit real*8 (a-h,o-z)
      real*8 rho(ndim),mu(ndim),lame(ndim),zi(ndim)
      character*40 infile
      character*74 card
      character*40 otfile
      character*40 ofile
      character*40 maple1
      character*40 octav1,octav2
      character*40 curve
c
c
      namelist /disper/ rho,mu,lame,nlay,nfreq,flo,delf,itmax,
     +zi,deltz,ofile,jsmax,modemx,
     +pvlcty,pfreq,zend,iskip,ksw,curve,epsk,
     +octav1,octav2
c
c
c
c...read input file name
c
c...test if input file in argument list on command line
      nargs=iargc()
      if(nargs.eq.0) then
      write(*,*)'  enter: name of input file'
      read(*,'(a)') infile
      else
      call getarg(1,infile)
      endif
c
c...open files
      open(09, file=infile, access='sequential')
      write(otfile,'(''show.tmp'')') 
      write(*,'(a)') otfile
c
c...read input data
      read(09,nml=disper)
c
c
      open(10, file=otfile, access='sequential')

c
      write(10,'(5x,''file: '',a)') infile
c
      rewind 9
    7 read(09,'(a)',end=8) card
      write(10,'(5x,a)') card
      write(*,'(5x,a)') card
      go to 7
    8 continue
      close(09)
c
c...trim deltz
      nz=int(zi(nlay)/deltz + 0.50)
      deltz=zi(nlay)/dfloat(nz)
      write(10,'(''      trimmed deltz='',f10.5)') deltz
      write(10,800)
800   format(//5x,'point',7x,'depth       beta',
     +'      alpha      rho'/)
c
      call show(rho,mu,lame,zi,nlay,ndim)
c
      close(10)
      stop
      end
c# |------------------------------------------------------------|
c  |                                         date: 20 mar 93    |
c  | author: p. michaels                                        |
c  |------------------------------------------------------------|
c  | show: display earth model                                  |
c  |                                                            |
c  |                                                            |
c  |------------------------------------------------------------|
c
      subroutine show(rho,mu,lame,zi,nlay,ndim)
      implicit real*8 (a-h,o-z)
      real*8 mu(ndim),lame(ndim),rho(ndim),zi(ndim)
c
c...compute model at regularly space depths
c
c
      do 100 j=1,nlay
      depth=zi(j)
      call gparms(rho,mu,lame,zi,nlay,ndim,
     +depth,grho,gmu,glame)
      alpha=dsqrt((glame+2.0d+00*gmu)/grho)
      beta=dsqrt(gmu/grho)
c
      write(10,900) j,depth,beta,alpha,grho
      write(*,900) j,depth,beta,alpha,grho
 900  format(5x,i5,5x,f8.3,2(2x,f10.2),2x,f7.1)
 100  continue
      return
      end
c# |------------------------------------------------------------|
c  |                                         date: 25 sep 92    |
c  | author: p. michaels                                        |
c  |------------------------------------------------------------|
c  | gparms: gets elastic parameters                            |
c  |                                                            |
c  |                                                            |
c  |------------------------------------------------------------|
c
      subroutine gparms(rho,mu,lame,zi,nlay,ndim,
     +depth,grho,gmu,glame)
      implicit real*8 (a-h,o-z)
      real*8 mu(ndim),lame(ndim),rho(ndim),zi(ndim)
c
c...determine current layer
      l1=1
      do 10 j=1,nlay
   10 if(depth.gt.zi(j)) l1=j
c    
      if(l1.lt.nlay) then
      l2=l1+1
      dz=zi(l2) - zi(l1)
      sloper=(rho(l2)-rho(l1))/dz
      slopel=(lame(l2)-lame(l1))/dz
      slopem=(mu(l2)-mu(l1))/dz
      z=depth-zi(l1)
      grho=sloper*z + rho(l1)
      gmu=slopem*z + mu(l1)
      glame=slopel*z + lame(l1)
      else
      grho=rho(nlay)
      gmu=mu(nlay)
      glame=lame(nlay)
      endif
      return
      end
