// |$Id: c_bsegin.c,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $      |
/* |------------------------------------------------------------|
   | Basic Seismic Utilities (BSU)                              |
   | LANGUAGE: C                                                |
   | AUTHOR: P. MICHAELS    http://cgiss.boisestate.edu/~pm     | 
   | FUNCTION NAME: c_bsegin.c                                  |
   | DIRECTORY: bsu-2.0.2/src/sublibC4                          |
   |------------------------------------------------------------|
   |  NOTICE:                                                   |
   |  Copyright (C) 2017 Paul Michaels                          |
   |  <pm@cgiss.boisestate.edu>                                 |
   |  This program is free software; you can                    |
   |  redistribute it and/or modify it under the terms          |
   |  of the GNU General Public License as published            |
   |  by the Free Software Foundation; either version           |
   |  3 of the License, or (at your option) any later           |
   |  version.  This program is distributed in the              |
   |  hope that it will be useful, but                          |
   |  WITHOUT ANY WARRANTY; without even the implied            |
   |  warranty of MERCHANTABILITY or FITNESS FOR A              |
   |  PARTICULAR PURPOSE.  See the GNU General Public           |
   |  License for more details.                                 |
   |  You should have received a copy of the GNU                |
   |  General Public License along with this program;           |
   |  if not, write to the Free Software Foundation,            |
   |  Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             |
   |------------------------------------------------------------|
   | purpose: input the jrec-th trace from input data           |
   |          set in bsegy format.                              |
   |                                                            |
   | input:  h1      =pointer to input file                     |
   |         jrec    =trace number to be input                  |
   |         npts    =number of points in a trace               |
   |                                                            |
   | output: hd      =pointer to header structure               |
   |         s1      =pointer to data array                     |
   |                                                            |
   |------------------------------------------------------------|
*/
      #include <stdio.h>
      #include <stdlib.h>
      #include "../C/include/c_bsegy.h"

      int c_bsegin(int jrec, float s1[], int npts,
        struct header *hd, FILE *h1)
     {
      long         offset;


      offset=(240+(long) npts*sizeof(float))*(jrec);
        if(fseek(h1,offset,SEEK_SET) !=0)
       {
        puts("ABORT--BSEGIN: can't position indicator");
        return(1);
       }

//...read header
        if(fread(hd,sizeof(char),240,h1)!=240)
            {
             puts("ABORT--BSEGIN: Error reading input header ");
             return(1);
            }

//...read data
        if(fread(s1,sizeof(float),npts,h1)!=npts)
            {
             puts("ABORT--BSEGIN: Error reading input data ");
             return(1);
            }
      return(0);
     }  //  end bsegin
