c |$Id: cshift.f,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $          |
c --------------------------------------------------------------
c | Basic Seismic Utilities                                    |
c | AUTHOR: P. MICHAELS  http://cgiss.boisestate.edu/~pm       | 
c | PROGRAM NAME: cshift.f                                     |
c | DIRECTORY: bsu-2.0.2/src/sublibF4                          |
c |------------------------------------------------------------|
c |  NOTICE:                                                   |
c |  Copyright (C) 2017 Paul Michaels                          |
c |  <pm@cgiss.boisestate.edu>                                 |
c |  This program is free software; you can                    |
c |  redistribute it and/or modify it under the terms          |
c |  of the GNU General Public License as published            |
c |  by the Free Software Foundation; either version           |
c |  3 of the License, or (at your option) any later           |
c |  version.  This program is distributed in the              |
c |  hope that it will be useful, but                          |
c |  WITHOUT ANY WARRANTY; without even the implied            |
c |  warranty of MERCHANTABILITY or FITNESS FOR A              |
c |  PARTICULAR PURPOSE.  See the GNU General Public           |
c |  License for more details.                                 |
c |  You should have received a copy of the GNU                |
c |  General Public License along with this program;           |
c |  if not, write to the Free Software Foundation,            |
c |  Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             |
c |------------------------------------------------------------|
c | cshift: applies static shift (phase rotation)              |
c |         in frequency domain                                |
c |     samin = sample interval                                |
c |     dt = static shift  +=delay  -=advance                  |
c --------------------------------------------------------------
c
      subroutine cshift(npts,x,dt,samin)
      complex x(*)
      pi=3.14159265358979323846264338327950
      pi2=pi*2.000000000000000000000000
      w=pi2*dt
      if(npts.le.0) return
      np2=npts/2
      npp1=np2+1
      do 1 i=1,np2
      f=float(i-1)/(float(npts)*samin)
      wf=w*f
      cosw=cos(wf)
      sinw=sin(wf)
      xr=real(x(i))
      xi=aimag(x(i))
      xrh=cosw*xr + sinw*xi
      xih=cosw*xi - sinw*xr
      x(i)=cmplx(xrh,xih)
    1 continue
      i=npts
      ing=-1
      do 2 ii=npp1,npts
      f=float(ing)/(float(npts)*samin)
      wf=w*f
      cosw=cos(wf)
      sinw=sin(wf)
      xr=real(x(i))
      xi=aimag(x(i))
      xrh=cosw*xr + sinw*xi
      xih=cosw*xi - sinw*xr
      x(i)=cmplx(xrh,xih)
      i=i-1
      ing=ing-1
    2 continue
      return
      end
