c |$Id: drum.f,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $          |
c --------------------------------------------------------------
c | Basic Seismic Utilities                                    |
c | AUTHOR: E. A. Robinson (1967, p.65)                        |
c | PROGRAM NAME: drum.f                                       |
c | DIRECTORY: bsu-2.0.2/src/sublibF4                          |
c |------------------------------------------------------------|
c | Copyright (c) 1967 by Holden-Day Inc. 500 Sansome St.,     |
c | San Francisco, all rights reserved                         |
c |                                                            |
c | Holden-Day Inc., Liquidation Trust, 1259 S.W. 14th Street  |
c | Boca Raton, FL 33486 Phone: (561)750-9229 Fax: 561.394.6809|
c |                                                            |
c |    This subroutine is included for distribution with Basic |
c | Seismic Utilities (BSU) by joint permission of the author, |
c | Enders Robinson, and Holden-Day Inc. Liquidation Trust,    |
c | Frederick H. Murphy, Trustee.  Being part of the BSU       |
c | package, it is governed by the terms of the GPL license,   |
c | and is distributed in the hope that it will be useful, but |
c | WITHOUT ANY WARRANTY; without even the implied warranty    |
c | of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    |
c | See the GNU General Public License for more details.       |
c | Paul Michaels, February 2002 <pm@cgiss.boisestate.edu>     |
c |                                                            |
c |------------------------------------------------------------|
c |Minor modifications, Fortran IV to Fortran 77 by P. Michaels|
c |Other Modifications: Phase unwrapping will fail if spectral |
c |notches are present (amplitude falls to near zero)          |
c |Here, unwrap from maximum amplitude index, jfmax            |
c |By centering on the peak spectral amplitude, and unwrapping |
c |in either direction from that point (rather than zero freq) |
c |a more useful unwrapping may be obtained.  PM               |
c |------------------------------------------------------------|
c |                      REFERENCE                             |
c | Robinson, E.A., 1967, "Multichannel Time Series Analysis   |
c |   with Digital Computer Programs", Holden-Day, 298p.       |
c |                                                            |
c |------------------------------------------------------------|
c |  Unwraps Phase                                             |
c |------------------------------------------------------------|
      subroutine drum(lphz,phz,jfmax)
      real*4 phz(*)
c---------top half
      jfmaxp1=jfmax+1
      pj=0.0
      do 40 i=jfmaxp1,lphz
      if(abs(phz(i)+pj-phz(i-1))-3.14159265) 40,40,10
   10 if(phz(i)+pj-phz(i-1)) 20,40,30
   20 pj=pj+3.14159265*2.0
      go to 40
   30 pj=pj-3.14159265*2.0
   40 phz(i)=phz(i)+pj
c---------bottom half
      pj=0.0
      jfmaxm1=jfmax-1
      do 41 i=jfmaxm1,2,-1
      if(abs(phz(i)+pj-phz(i-1))-3.14159265) 41,41,11
   11 if(phz(i)+pj-phz(i-1)) 21,41,31
   21 pj=pj+3.14159265*2.0
      go to 41
   31 pj=pj-3.14159265*2.0
   41 phz(i)=phz(i)+pj
      return
      end
